#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy2 Experiment Builder (v1.85.6),
    on Thu Apr 12 12:31:14 2018
If you publish work using this script please cite the PsychoPy publications:
    Peirce, JW (2007) PsychoPy - Psychophysics software in Python.
        Journal of Neuroscience Methods, 162(1-2), 8-13.
    Peirce, JW (2009) Generating stimuli for neuroscience using PsychoPy.
        Frontiers in Neuroinformatics, 2:10. doi: 10.3389/neuro.11.010.2008
"""

from __future__ import absolute_import, division
from psychopy import locale_setup, sound, gui, visual, core, data, event, logging
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)
import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__)).decode(sys.getfilesystemencoding())
os.chdir(_thisDir)

# Store info about the experiment session
expName = 'Lab 4 Afterimage Experiment'  # from the Builder filename that created this script
expInfo = {'participant':'', 'session':'001'}
dlg = gui.DlgFromDict(dictionary=expInfo, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath=u'/Users/hebr5587/Downloads/Afterimage Experiment/Lab 4 Afterimage Experiment.psyexp',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=(2560, 1440), fullscr=True, screen=0,
    allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True)
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# Initialize components for Routine "Welcome"
WelcomeClock = core.Clock()
Instructions = visual.TextStim(win=win, name='Instructions',
    text=u'                Welcome! \n\nIn this experiment we will be measuring the duration of an afterimage.\n\n\n\n\nPress "M" if you are male, "F" if you are female, and "O" for other.',
    font=u'Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color=u'white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "Instructions_1"
Instructions_1Clock = core.Clock()
Instruction_1 = visual.TextStim(win=win, name='Instruction_1',
    text='You will first be shown an adapting stumulus image, shown below. You will focus your attention on the fixation point on the image as long as it is presented on the screen. The image will then be replaced with the test image.\n\n\n\n\n\n\n                (press space)',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);
instr_image_1 = visual.ImageStim(
    win=win, name='instr_image_1',
    image='adaptation image.JPG', mask=None,
    ori=0, pos=(0,-0.25), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)

# Initialize components for Routine "Instructions_2"
Instructions_2Clock = core.Clock()
Instruction_2 = visual.TextStim(win=win, name='Instruction_2',
    text='The test image, shown below, will appear as one continuous image without these contrasting halves. The negative afterimage may show a contrast at first, but this effect will fade. You will then respond by pressing the space bar when the left half of the image returns to yellow and the right half returns to blue.\n\n\n\n\n\n\n                (press space)',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);
instr_image_2 = visual.ImageStim(
    win=win, name='instr_image_2',
    image='test image.JPG', mask=None,
    ori=0, pos=(0, -0.4), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=-1.0)

# Initialize components for Routine "Instructions_3"
Instructions_3Clock = core.Clock()
text = visual.TextStim(win=win, name='text',
    text='Try not to respond until the image has completely returned to its original state.\n\nYou will now do a trial run of the experiment so you know what you are looking for during the actual experiment.\n\nPress space to begin the trial.',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
trial_image_1 = visual.ImageStim(
    win=win, name='trial_image_1',
    image='adaptation image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "practice_trial"
practice_trialClock = core.Clock()
trial_image_2 = visual.ImageStim(
    win=win, name='trial_image_2',
    image='test image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "practice_break"
practice_breakClock = core.Clock()
break_practice = visual.TextStim(win=win, name='break_practice',
    text='Give your eyes a 30 second rest!',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "Instructions_4"
Instructions_4Clock = core.Clock()
Instruction_4 = visual.TextStim(win=win, name='Instruction_4',
    text='You will now begin the experiment.\n\nPress space to continue.',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
trial_image_1 = visual.ImageStim(
    win=win, name='trial_image_1',
    image='adaptation image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "Trial_1"
Trial_1Clock = core.Clock()
trial_image = visual.ImageStim(
    win=win, name='trial_image',
    image='test image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "break_1"
break_1Clock = core.Clock()
break_2 = visual.TextStim(win=win, name='break_2',
    text='Give your eyes a 30 second rest!',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);
text_2 = visual.TextStim(win=win, name='text_2',
    text='\n\n\n\n\n\n            Press space to continue.',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=-1.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
trial_image_1 = visual.ImageStim(
    win=win, name='trial_image_1',
    image='adaptation image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "Trial_2"
Trial_2Clock = core.Clock()
trial_image2 = visual.ImageStim(
    win=win, name='trial_image2',
    image='test image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "break_1"
break_1Clock = core.Clock()
break_2 = visual.TextStim(win=win, name='break_2',
    text='Give your eyes a 30 second rest!',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);
text_2 = visual.TextStim(win=win, name='text_2',
    text='\n\n\n\n\n\n            Press space to continue.',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=-1.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
trial_image_1 = visual.ImageStim(
    win=win, name='trial_image_1',
    image='adaptation image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "Trial_3"
Trial_3Clock = core.Clock()
trial_image3 = visual.ImageStim(
    win=win, name='trial_image3',
    image='test image.JPG', mask=None,
    ori=0, pos=(0, 0), size=(0.7, 0.7),
    color=[1,1,1], colorSpace='rgb', opacity=1,
    flipHoriz=False, flipVert=False,
    texRes=128, interpolate=True, depth=0.0)

# Initialize components for Routine "Thank_You"
Thank_YouClock = core.Clock()
thank_you = visual.TextStim(win=win, name='thank_you',
    text='The experiment is now complete.\n\nThank you for participating!',
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1,
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "Welcome"-------
t = 0
WelcomeClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
gender = event.BuilderKeyResponse()
# keep track of which components have finished
WelcomeComponents = [Instructions, gender]
for thisComponent in WelcomeComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Welcome"-------
while continueRoutine:
    # get current time
    t = WelcomeClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Instructions* updates
    if t >= 0.0 and Instructions.status == NOT_STARTED:
        # keep track of start time/frame for later
        Instructions.tStart = t
        Instructions.frameNStart = frameN  # exact frame index
        Instructions.setAutoDraw(True)
    
    # *gender* updates
    if t >= 0.5 and gender.status == NOT_STARTED:
        # keep track of start time/frame for later
        gender.tStart = t
        gender.frameNStart = frameN  # exact frame index
        gender.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(gender.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if gender.status == STARTED:
        theseKeys = event.getKeys(keyList=['m', 'f', 'o'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            gender.keys = theseKeys[-1]  # just the last key pressed
            gender.rt = gender.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in WelcomeComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Welcome"-------
for thisComponent in WelcomeComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if gender.keys in ['', [], None]:  # No response was made
    gender.keys=None
thisExp.addData('gender.keys',gender.keys)
if gender.keys != None:  # we had a response
    thisExp.addData('gender.rt', gender.rt)
thisExp.nextEntry()
# the Routine "Welcome" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "Instructions_1"-------
t = 0
Instructions_1Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
response_2 = event.BuilderKeyResponse()
# keep track of which components have finished
Instructions_1Components = [Instruction_1, instr_image_1, response_2]
for thisComponent in Instructions_1Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Instructions_1"-------
while continueRoutine:
    # get current time
    t = Instructions_1Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Instruction_1* updates
    if t >= 0.0 and Instruction_1.status == NOT_STARTED:
        # keep track of start time/frame for later
        Instruction_1.tStart = t
        Instruction_1.frameNStart = frameN  # exact frame index
        Instruction_1.setAutoDraw(True)
    
    # *instr_image_1* updates
    if t >= 0.0 and instr_image_1.status == NOT_STARTED:
        # keep track of start time/frame for later
        instr_image_1.tStart = t
        instr_image_1.frameNStart = frameN  # exact frame index
        instr_image_1.setAutoDraw(True)
    
    # *response_2* updates
    if t >= 0.5 and response_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        response_2.tStart = t
        response_2.frameNStart = frameN  # exact frame index
        response_2.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if response_2.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Instructions_1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Instructions_1"-------
for thisComponent in Instructions_1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "Instructions_1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "Instructions_2"-------
t = 0
Instructions_2Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
response_3 = event.BuilderKeyResponse()
# keep track of which components have finished
Instructions_2Components = [Instruction_2, instr_image_2, response_3]
for thisComponent in Instructions_2Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Instructions_2"-------
while continueRoutine:
    # get current time
    t = Instructions_2Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Instruction_2* updates
    if t >= 0.0 and Instruction_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        Instruction_2.tStart = t
        Instruction_2.frameNStart = frameN  # exact frame index
        Instruction_2.setAutoDraw(True)
    
    # *instr_image_2* updates
    if t >= 0.0 and instr_image_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        instr_image_2.tStart = t
        instr_image_2.frameNStart = frameN  # exact frame index
        instr_image_2.setAutoDraw(True)
    
    # *response_3* updates
    if t >= 0.0 and response_3.status == NOT_STARTED:
        # keep track of start time/frame for later
        response_3.tStart = t
        response_3.frameNStart = frameN  # exact frame index
        response_3.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if response_3.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Instructions_2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Instructions_2"-------
for thisComponent in Instructions_2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "Instructions_2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "Instructions_3"-------
t = 0
Instructions_3Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
response_4 = event.BuilderKeyResponse()
# keep track of which components have finished
Instructions_3Components = [text, response_4]
for thisComponent in Instructions_3Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Instructions_3"-------
while continueRoutine:
    # get current time
    t = Instructions_3Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text* updates
    if t >= 0.0 and text.status == NOT_STARTED:
        # keep track of start time/frame for later
        text.tStart = t
        text.frameNStart = frameN  # exact frame index
        text.setAutoDraw(True)
    
    # *response_4* updates
    if t >= 0.5 and response_4.status == NOT_STARTED:
        # keep track of start time/frame for later
        response_4.tStart = t
        response_4.frameNStart = frameN  # exact frame index
        response_4.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if response_4.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Instructions_3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Instructions_3"-------
for thisComponent in Instructions_3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "Instructions_3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "trial"-------
t = 0
trialClock.reset()  # clock
frameN = -1
continueRoutine = True
routineTimer.add(21.000000)
# update component parameters for each repeat
# keep track of which components have finished
trialComponents = [trial_image_1]
for thisComponent in trialComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "trial"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = trialClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image_1* updates
    if t >= 0.0 and trial_image_1.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image_1.tStart = t
        trial_image_1.frameNStart = frameN  # exact frame index
        trial_image_1.setAutoDraw(True)
    frameRemains = 0.0 + 21.0- win.monitorFramePeriod * 0.75  # most of one frame period left
    if trial_image_1.status == STARTED and t >= frameRemains:
        trial_image_1.setAutoDraw(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "trial"-------
for thisComponent in trialComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# ------Prepare to start Routine "practice_trial"-------
t = 0
practice_trialClock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
practice_response = event.BuilderKeyResponse()
# keep track of which components have finished
practice_trialComponents = [trial_image_2, practice_response]
for thisComponent in practice_trialComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "practice_trial"-------
while continueRoutine:
    # get current time
    t = practice_trialClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image_2* updates
    if t >= 0.0 and trial_image_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image_2.tStart = t
        trial_image_2.frameNStart = frameN  # exact frame index
        trial_image_2.setAutoDraw(True)
    
    # *practice_response* updates
    if t >= 0.0 and practice_response.status == NOT_STARTED:
        # keep track of start time/frame for later
        practice_response.tStart = t
        practice_response.frameNStart = frameN  # exact frame index
        practice_response.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if practice_response.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in practice_trialComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "practice_trial"-------
for thisComponent in practice_trialComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "practice_trial" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "practice_break"-------
t = 0
practice_breakClock.reset()  # clock
frameN = -1
continueRoutine = True
routineTimer.add(30.000000)
# update component parameters for each repeat
# keep track of which components have finished
practice_breakComponents = [break_practice]
for thisComponent in practice_breakComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "practice_break"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = practice_breakClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *break_practice* updates
    if t >= 0.0 and break_practice.status == NOT_STARTED:
        # keep track of start time/frame for later
        break_practice.tStart = t
        break_practice.frameNStart = frameN  # exact frame index
        break_practice.setAutoDraw(True)
    frameRemains = 0.0 + 30.0- win.monitorFramePeriod * 0.75  # most of one frame period left
    if break_practice.status == STARTED and t >= frameRemains:
        break_practice.setAutoDraw(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in practice_breakComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "practice_break"-------
for thisComponent in practice_breakComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# ------Prepare to start Routine "Instructions_4"-------
t = 0
Instructions_4Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
response_6 = event.BuilderKeyResponse()
# keep track of which components have finished
Instructions_4Components = [Instruction_4, response_6]
for thisComponent in Instructions_4Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Instructions_4"-------
while continueRoutine:
    # get current time
    t = Instructions_4Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *Instruction_4* updates
    if t >= 0.0 and Instruction_4.status == NOT_STARTED:
        # keep track of start time/frame for later
        Instruction_4.tStart = t
        Instruction_4.frameNStart = frameN  # exact frame index
        Instruction_4.setAutoDraw(True)
    
    # *response_6* updates
    if t >= 0.5 and response_6.status == NOT_STARTED:
        # keep track of start time/frame for later
        response_6.tStart = t
        response_6.frameNStart = frameN  # exact frame index
        response_6.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if response_6.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Instructions_4Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Instructions_4"-------
for thisComponent in Instructions_4Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "Instructions_4" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "trial"-------
t = 0
trialClock.reset()  # clock
frameN = -1
continueRoutine = True
routineTimer.add(21.000000)
# update component parameters for each repeat
# keep track of which components have finished
trialComponents = [trial_image_1]
for thisComponent in trialComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "trial"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = trialClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image_1* updates
    if t >= 0.0 and trial_image_1.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image_1.tStart = t
        trial_image_1.frameNStart = frameN  # exact frame index
        trial_image_1.setAutoDraw(True)
    frameRemains = 0.0 + 21.0- win.monitorFramePeriod * 0.75  # most of one frame period left
    if trial_image_1.status == STARTED and t >= frameRemains:
        trial_image_1.setAutoDraw(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "trial"-------
for thisComponent in trialComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# ------Prepare to start Routine "Trial_1"-------
t = 0
Trial_1Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
trial_resp_1 = event.BuilderKeyResponse()
# keep track of which components have finished
Trial_1Components = [trial_image, trial_resp_1]
for thisComponent in Trial_1Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Trial_1"-------
while continueRoutine:
    # get current time
    t = Trial_1Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image* updates
    if t >= 0.0 and trial_image.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image.tStart = t
        trial_image.frameNStart = frameN  # exact frame index
        trial_image.setAutoDraw(True)
    
    # *trial_resp_1* updates
    if t >= 0.0 and trial_resp_1.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_resp_1.tStart = t
        trial_resp_1.frameNStart = frameN  # exact frame index
        trial_resp_1.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(trial_resp_1.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if trial_resp_1.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            trial_resp_1.keys = theseKeys[-1]  # just the last key pressed
            trial_resp_1.rt = trial_resp_1.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Trial_1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Trial_1"-------
for thisComponent in Trial_1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if trial_resp_1.keys in ['', [], None]:  # No response was made
    trial_resp_1.keys=None
thisExp.addData('trial_resp_1.keys',trial_resp_1.keys)
if trial_resp_1.keys != None:  # we had a response
    thisExp.addData('trial_resp_1.rt', trial_resp_1.rt)
thisExp.nextEntry()
# the Routine "Trial_1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "break_1"-------
t = 0
break_1Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_2 = event.BuilderKeyResponse()
# keep track of which components have finished
break_1Components = [break_2, text_2, key_resp_2]
for thisComponent in break_1Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "break_1"-------
while continueRoutine:
    # get current time
    t = break_1Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *break_2* updates
    if t >= 0.0 and break_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        break_2.tStart = t
        break_2.frameNStart = frameN  # exact frame index
        break_2.setAutoDraw(True)
    
    # *text_2* updates
    if t >= 30.0 and text_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_2.tStart = t
        text_2.frameNStart = frameN  # exact frame index
        text_2.setAutoDraw(True)
    
    # *key_resp_2* updates
    if t >= 30.0 and key_resp_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_2.tStart = t
        key_resp_2.frameNStart = frameN  # exact frame index
        key_resp_2.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if key_resp_2.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in break_1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "break_1"-------
for thisComponent in break_1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "break_1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "trial"-------
t = 0
trialClock.reset()  # clock
frameN = -1
continueRoutine = True
routineTimer.add(21.000000)
# update component parameters for each repeat
# keep track of which components have finished
trialComponents = [trial_image_1]
for thisComponent in trialComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "trial"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = trialClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image_1* updates
    if t >= 0.0 and trial_image_1.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image_1.tStart = t
        trial_image_1.frameNStart = frameN  # exact frame index
        trial_image_1.setAutoDraw(True)
    frameRemains = 0.0 + 21.0- win.monitorFramePeriod * 0.75  # most of one frame period left
    if trial_image_1.status == STARTED and t >= frameRemains:
        trial_image_1.setAutoDraw(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "trial"-------
for thisComponent in trialComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# ------Prepare to start Routine "Trial_2"-------
t = 0
Trial_2Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
trial_resp_2 = event.BuilderKeyResponse()
# keep track of which components have finished
Trial_2Components = [trial_image2, trial_resp_2]
for thisComponent in Trial_2Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Trial_2"-------
while continueRoutine:
    # get current time
    t = Trial_2Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image2* updates
    if t >= 0.0 and trial_image2.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image2.tStart = t
        trial_image2.frameNStart = frameN  # exact frame index
        trial_image2.setAutoDraw(True)
    
    # *trial_resp_2* updates
    if t >= 0.0 and trial_resp_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_resp_2.tStart = t
        trial_resp_2.frameNStart = frameN  # exact frame index
        trial_resp_2.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(trial_resp_2.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if trial_resp_2.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            trial_resp_2.keys = theseKeys[-1]  # just the last key pressed
            trial_resp_2.rt = trial_resp_2.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Trial_2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Trial_2"-------
for thisComponent in Trial_2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if trial_resp_2.keys in ['', [], None]:  # No response was made
    trial_resp_2.keys=None
thisExp.addData('trial_resp_2.keys',trial_resp_2.keys)
if trial_resp_2.keys != None:  # we had a response
    thisExp.addData('trial_resp_2.rt', trial_resp_2.rt)
thisExp.nextEntry()
# the Routine "Trial_2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "break_1"-------
t = 0
break_1Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
key_resp_2 = event.BuilderKeyResponse()
# keep track of which components have finished
break_1Components = [break_2, text_2, key_resp_2]
for thisComponent in break_1Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "break_1"-------
while continueRoutine:
    # get current time
    t = break_1Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *break_2* updates
    if t >= 0.0 and break_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        break_2.tStart = t
        break_2.frameNStart = frameN  # exact frame index
        break_2.setAutoDraw(True)
    
    # *text_2* updates
    if t >= 30.0 and text_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        text_2.tStart = t
        text_2.frameNStart = frameN  # exact frame index
        text_2.setAutoDraw(True)
    
    # *key_resp_2* updates
    if t >= 30.0 and key_resp_2.status == NOT_STARTED:
        # keep track of start time/frame for later
        key_resp_2.tStart = t
        key_resp_2.frameNStart = frameN  # exact frame index
        key_resp_2.status = STARTED
        # keyboard checking is just starting
        event.clearEvents(eventType='keyboard')
    if key_resp_2.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in break_1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "break_1"-------
for thisComponent in break_1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "break_1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "trial"-------
t = 0
trialClock.reset()  # clock
frameN = -1
continueRoutine = True
routineTimer.add(21.000000)
# update component parameters for each repeat
# keep track of which components have finished
trialComponents = [trial_image_1]
for thisComponent in trialComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "trial"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = trialClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image_1* updates
    if t >= 0.0 and trial_image_1.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image_1.tStart = t
        trial_image_1.frameNStart = frameN  # exact frame index
        trial_image_1.setAutoDraw(True)
    frameRemains = 0.0 + 21.0- win.monitorFramePeriod * 0.75  # most of one frame period left
    if trial_image_1.status == STARTED and t >= frameRemains:
        trial_image_1.setAutoDraw(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "trial"-------
for thisComponent in trialComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)

# ------Prepare to start Routine "Trial_3"-------
t = 0
Trial_3Clock.reset()  # clock
frameN = -1
continueRoutine = True
# update component parameters for each repeat
trial_resp_3 = event.BuilderKeyResponse()
# keep track of which components have finished
Trial_3Components = [trial_image3, trial_resp_3]
for thisComponent in Trial_3Components:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Trial_3"-------
while continueRoutine:
    # get current time
    t = Trial_3Clock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *trial_image3* updates
    if t >= 0.0 and trial_image3.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_image3.tStart = t
        trial_image3.frameNStart = frameN  # exact frame index
        trial_image3.setAutoDraw(True)
    
    # *trial_resp_3* updates
    if t >= 0.0 and trial_resp_3.status == NOT_STARTED:
        # keep track of start time/frame for later
        trial_resp_3.tStart = t
        trial_resp_3.frameNStart = frameN  # exact frame index
        trial_resp_3.status = STARTED
        # keyboard checking is just starting
        win.callOnFlip(trial_resp_3.clock.reset)  # t=0 on next screen flip
        event.clearEvents(eventType='keyboard')
    if trial_resp_3.status == STARTED:
        theseKeys = event.getKeys(keyList=['space'])
        
        # check for quit:
        if "escape" in theseKeys:
            endExpNow = True
        if len(theseKeys) > 0:  # at least one key was pressed
            trial_resp_3.keys = theseKeys[-1]  # just the last key pressed
            trial_resp_3.rt = trial_resp_3.clock.getTime()
            # a response ends the routine
            continueRoutine = False
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Trial_3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Trial_3"-------
for thisComponent in Trial_3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if trial_resp_3.keys in ['', [], None]:  # No response was made
    trial_resp_3.keys=None
thisExp.addData('trial_resp_3.keys',trial_resp_3.keys)
if trial_resp_3.keys != None:  # we had a response
    thisExp.addData('trial_resp_3.rt', trial_resp_3.rt)
thisExp.nextEntry()
# the Routine "Trial_3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "Thank_You"-------
t = 0
Thank_YouClock.reset()  # clock
frameN = -1
continueRoutine = True
routineTimer.add(5.000000)
# update component parameters for each repeat
# keep track of which components have finished
Thank_YouComponents = [thank_you]
for thisComponent in Thank_YouComponents:
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED

# -------Start Routine "Thank_You"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = Thank_YouClock.getTime()
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *thank_you* updates
    if t >= 0.0 and thank_you.status == NOT_STARTED:
        # keep track of start time/frame for later
        thank_you.tStart = t
        thank_you.frameNStart = frameN  # exact frame index
        thank_you.setAutoDraw(True)
    frameRemains = 0.0 + 5.0- win.monitorFramePeriod * 0.75  # most of one frame period left
    if thank_you.status == STARTED and t >= frameRemains:
        thank_you.setAutoDraw(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in Thank_YouComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # check for quit (the Esc key)
    if endExpNow or event.getKeys(keyList=["escape"]):
        core.quit()
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Thank_You"-------
for thisComponent in Thank_YouComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
